Ruby - Bug #11483

internal.h included after math.h in complex.c
08/24/2015 06:55 PM - ReiOdaira (Rei Odaira)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.3.0dev (2015-08-23 trunk 51669) |Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:
[powerpc-aix7.1.2.0] UNKNOWN

Description

r51313 modified complex.c to include internal.h after math.h, so that ruby/missing.h (included from internal.h) can test whether M_PI
is defined or not in math.h. Unfortunately, ruby/config.h, which is included from internal.h, defines _LARGE_FILES, which must be
defined before sys/types.h is included from math.h. Otherwise, in AlX, off_t would be incorrectly defined as a 32-bit integer even
when large files are used.

-—— complex.c (revision 51312)
+++ complex.c (revision 51313)
@@ -5,12 +5,12 Q@@

which is written in ruby.

*/

—#include "internal.h"

#if defined _MSC_VER

/* Microsoft Visual C does not define M_PI and others by default */
# define _USE_MATH_DEFINES 1

fendif

#include <math.h>
+#include "internal.h"

#define NDEBUG
#include <assert.h>

There would be a couple of workarounds to fix this problem, but since | am relatively new to the Ruby core, | am wondering what
would be the most acceptable way.

Related issues:
Blocks Ruby - Misc #11516: Ruby 2.3.0 release engeneering Closed

Associated revisions

Revision c3b02d572c86ba128c25a22d00b3ad3c36ffe295 - 09/23/2015 03:08 PM - Rei Odaira

complex.c: ruby/config.h must be included before math.h
because it defines _LARGE_FILES on AlX and _LARGE_FILES
must be defined before sys/types.h is included from math.h.
[Bug #11483]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@51922 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ¢3b02d57 - 09/23/2015 03:08 PM - Rei Odaira

complex.c: ruby/config.h must be included before math.h
because it defines _LARGE_FILES on AlX and _LARGE_FILES
must be defined before sys/types.h is included from math.h.
[Bug #11483]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@51922 b2dd03c8-39d4-4d8f-98ff-823fe690080e

History

#1 - 09/09/2015 06:13 AM - naruse (Yui NARUSE)
- Blocks Misc #11516: Ruby 2.3.0 release engeneering added

#2 - 09/09/2015 09:36 PM - ReiOdaira (Rei Odaira)
Possible options:
1. Define M_Pl and M_PI_2 in complex.c
2. Define _LARGE_FILES not in config.h but in a compiler option
3. Include ruby/config.h before math.h but keep internal.h included after math.h in complex.c
4. Any other options?
Option 3 looks reasonable if it is allowed to directly include ruby/config.h.
#3 - 09/23/2015 03:09 PM - Anonymous
- Status changed from Open to Closed

Applied in changeset r51922.

complex.c: ruby/config.h must be included before math.h
because it defines _LARGE_FILES on AlX and _LARGE_FILES
must be defined before sys/types.h is included from math.h.
[Bug #11483]
